' File: FindElemGroups.BAS
' Version: Version 1
' Date: Mar 15, 2017
' Author: Rachel Backes, ATA Engineering
' Support: rachel.backes@ata-e.com
' www.ata-plmsoftware.com
'
' Description: This API seraches for an element in a set of user selected groups and reports
'	which group(s) the element is in to the message window.
'
'Copyright (c) <2019> <ATA Engineering, Inc.>
'
'Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
'associated documentation files (the "Software") to use, copy, modify, merge, and/or distribute
'royalty-free copies of the Software, and to permit persons to whom the Software is furnished
'to do so, subject to the following conditions:
'The above copyright notice and this permission notice shall be included in all copies or
'substantial portions of the Software.
'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
'INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
'FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
'IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
'OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'
Sub Main
    Dim App As femap.model
    Set App = feFemap()

    Dim el As femap.Elem
    Set el = App.feElem

    Dim gr As femap.Group
    Set gr = App.feGroup

    Dim grSet As femap.Set
    Set grSet = App.feSet

    Dim lst As femap.Set
    Set lst=App.feSet

    Dim grLst As String, c As Long

	App.feAppMessage(1,"Find Element Groups")

	'User selects element to search for
    rc = el.SelectID("Select the element to search for.")
	If rc >=0 Then
		GoTo Slan
	End If

    grLst = "Element"+Str%(el.ID)+" is found in group(s):"

    'User selects which groups to search
    rc = grSet.Select(FT_GROUP,True,"Select groups to search.")
    If rc >=0 Then
		GoTo Slan
	End If

    'Loop through groups
    grSet.Reset()
    c=0
	While grSet.Next()
		gr.Get(grSet.CurrentID)

		'Create list of elems in group

		Set lst = gr.List(FGR_ELEM)

		'Check if there are any elem in the group
		If Not lst Is Nothing Then
			'See if the elment ID is in the group
			check = lst.IsAdded(el.ID)
			'If it is, add it to the list
			If check <0 Then
				grLst = grLst + Str%(gr.ID)+","
				c=c+1
			End If
		End If
	Wend

	Dim LgrLst As Long
	LgrLst = Len(grLst)-1
	grLst = Left(grLst,LgrLst)

	If c=0 Then
		grLst = "Element"+Str%(el.ID)+" is not in any of the selected groups."
	End If
		App.feAppMessage(0,grLst)


	Slan:

End Sub
